/*
Copyright (C) 2016 Centro de Computacao Cientifica e Software Livre
Departamento de Informatica - Universidade Federal do Parana - C3SL/UFPR

This file is part of simcaq-node.

simcaq-node is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

simcaq-node is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with simcaq-node.  If not, see <https://www.gnu.org/licenses/>.
*/

const libs = `${process.cwd()}/libs`;
const log = require(`${libs}/log`)(module);
const config = require(`${libs}/config`);
const nodemailer = require('nodemailer');
const htmlToText = require('nodemailer-html-to-text').htmlToText;

let transporter = nodemailer.createTransport({
    host: config.email.host,
    port: config.email.port,
    secure: config.email.secure,
    ignoreTLS: config.email.ignoreTLS
});

transporter.use('compile', htmlToText());

// verify connection configuration
transporter.verify(function(error, success) {
   if (error) {
        log.error(error);
   } else {
        log.info('Email server is ready to take our messages');
   }
});

const mailOptions = {
    from: config.email.from
};

module.exports = function send(options, cb) {
    let opt = Object.assign({}, mailOptions, options);
    transporter.sendMail(opt, (err, info) => {
        if(err) {
            return cb(err);
        }
        cb(null, info);
    });
};