/*
Copyright (C) 2019 Centro de Computacao Cientifica e Software Livre
Departamento de Informatica - Universidade Federal do Parana - C3SL/UFPR

This file is part of SMPPIR-Node.

SMPPIR-Node is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

SMPPIR-Node is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with SMPPIR-Node.  If not, see <https://www.gnu.org/licenses/>.
*/



const express = require('express');

const quilombola_metrics = express.Router();

const libs = `${process.cwd()}/libs`;

const squel = require('squel');

const query = require(`${libs}/middlewares/query`).query;

const response = require(`${libs}/middlewares/response`);

const ReqQueryFields = require(`${libs}/middlewares/reqQueryFields`);

const rqf = new ReqQueryFields();

rqf.addField({
    name: 'filter',
    field: false,
    where: true,
}).addField({
    name: 'dims',
    field: true,
    where: false,
})
.addValue({
    name: 'year',
    table: 'cad_unico_quilombola_metrics_ag',
    tableField: 'ano_censo',
    resultField: 'ano_pesquisa',
    where: {
        relation: '=',
        type: 'integer',
        field: 'ano_censo',
    },
})

;


quilombola_metrics.get('/', rqf.parse(), rqf.build(), (req, res, next) => {
    console.log(req.sql.toString());
    req.sql.field('*')
        .from('cad_unico_quilombola_metrics_ag');
    next();
}, query, response('cad_unico'));

module.exports = quilombola_metrics;
